freeslot("sfx_trbuff")

personaList["lloydskillset"].trait = "masterforce"
attackDefs["masterforce"] = {
		name = "Force",
		type = ATK_PASSIVE,
		passive = PSV_STARTBATTLE,
		implicit = "masterforce.pt2",
		desc = "Starts the battle with a STR buff.\nWhen HP is below 20% or lower gains \n2 stage STR Buff.",
		traitheader = "\x82".."Master Quartz".."\x80"..":",
		norandom = true,
		norogue = true,
		anim = function(mo, targets, hittargets, timer) 
			buffStat(mo, "atk")
			playSound(mo.battlen, sfx_trbuff)
		end,
	}

attackDefs["masterforce.pt2"] = {
		name = "Force",
		type = ATK_PASSIVE,
		passive = PSV_STARTTURN,
		desc = "Starts the battle with a STR buff.\nWhen HP is below 20% or lower gains 2 stage STR Buff.",
		norandom = true,
		norogue = true,
		anim = function(mo, targets, hittargets, timer)
			if mo.hp <= mo.maxhp/5
			or mo.continue_masterforce --in case you somehow get healed while the anim is playing
				mo.continue_masterforce = true
				if timer == 15
					playSound(mo.battlen, sfx_trbuff)
					buffStat(mo, "atk", 50)
				elseif timer > 15 and timer <= 30
					for i = 1, 8
						local thok = P_SpawnMobj(mo.x+P_RandomRange(-70, 70)*FRACUNIT, mo.y+P_RandomRange(-70, 70)*FRACUNIT, mo.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_ORANGE
						thok.tics = P_RandomRange(10, 35)
					end
				elseif timer == 35
					mo.continue_masterforce = nil
					return true
				end
			else		
				return true
			end
		end,
	}
	
personaList["estelleskillset"].trait = "mastercanon"
attackDefs["mastercanon"] = {
		name = "Canon",
		type = ATK_PASSIVE|ATK_HEAL,
		desc = "Increases healing power by 25%.\nRecovers 4% HP per turn",
		power = 25,
		passive = PSV_BOOST,
		implicit = "mastercanon.pt2",
		traitheader = "\x82".."Master Quartz".."\x80"..":",
		norandom = true,
		norogue = true,
	}

attackDefs["mastercanon.pt2"] = {
		name = "Canon",
		type = ATK_PASSIVE,
		passive = PSV_STARTTURN,
		desc = "Increases healing power by 25%.\nRecovers 4% HP per turn",
		norandom = true,
		norogue = true,		
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
				local heals = max(1, target.maxhp*4 / 100)
				playSound(mo.battlen, sfx_lsheal)
				damageObject(target, -heals, DMG_NORMAL, true)
				for i = 1,10
					local ol = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_BLUE
					ol.scale = 1
					ol.destscale = mo.scale*3
					ol.scalespeed = (mo.scale*3)/15
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end
			end	
			
			if timer >= 1 and timer <= 10
			and (timer%5) == 0
				local s = P_SpawnMobj(mo.x + P_RandomRange(-58, 58)<<FRACBITS, mo.y + P_RandomRange(-58, 58)<<FRACBITS, mo.z + P_RandomRange(0, 50)<<FRACBITS, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = FRACUNIT*1			
			
			elseif timer == 20
				return true
			end
		end,
	}
	
personaList["joshuaskillset"].trait = "mastersubaru"
attackDefs["mastersubaru"] = {
		name = "Subaru",
		type = ATK_PASSIVE|ATK_SLASH|ATK_STRIKE|ATK_PIERCE|ATK_FIRE|ATK_ICE|ATK_WIND|ATK_ELEC|ATK_PSY|ATK_NUCLEAR|ATK_CURSE|ATK_BLESS,
		desc = "Dodges all attacks by 7%(Almighty excluded).\nWhen HP is below 20% or lower gains \n2 stage AGI Buff.",
		power = 7,
		passive = PSV_DODGE,
		implicit = "mastersubaru.pt2",
		traitheader = "\x82".."Master Quartz".."\x80"..":",
		norandom = true,
		norogue = true,
	}

attackDefs["mastersubaru.pt2"] = {
		name = "Subaru",
		type = ATK_PASSIVE,
		passive = PSV_STARTTURN,
		desc = "Dodges all attacks by 7%(Almighty excluded).\nWhen HP is below 20% or lower gains a AGI Buff.",
		norandom = true,
		norogue = true,		
		anim = function(mo, targets, hittargets, timer)
			if mo.hp <= mo.maxhp/5
			or mo.continue_masterforce --in case you somehow get healed while the anim is playing
				mo.continue_masterforce = true
				if timer == 15
					playSound(mo.battlen, sfx_trbuff)
					buffStat(mo, "agi", 25)
				elseif timer > 15 and timer <= 30
					for i = 1, 8
						local thok = P_SpawnMobj(mo.x+P_RandomRange(-70, 70)*FRACUNIT, mo.y+P_RandomRange(-70, 70)*FRACUNIT, mo.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_EMERALD
						thok.tics = P_RandomRange(10, 35)
					end
				elseif timer == 35
					mo.continue_masterforce = nil
					return true
				end
			else		
				return true
			end
		end,
	}	
	
personaList["titaskillset"].trait = "masterdunamis"
attackDefs["masterdunamis"] = {
		name = "Dunamis",
		type = ATK_PASSIVE,
		desc = "Recover a little bit of SP when \nattacking. When HP is 20% or \nlower gain a MAG buff..",
		passive = PSV_TRIGGERDAMAGE,
		implicit = "masterdunamis.pt2",
		traitheader = "\x82".."Master Quartz".."\x80"..":",
		norandom = true,
		norogue = true,		
		anim = function(mo, target, dmg, crit)
			if dmg
				damageSP(mo, -(dmg/20))
			end	
		end,
	}

attackDefs["masterdunamis.pt2"] = {
		name = "Dunamis",
		type = ATK_PASSIVE,
		desc = "Recover a little bit of SP when \nattacking. When HP is 20% or \nlower gain a MAG buff.",
		passive = PSV_STARTTURN,
		traitheader = "\x82".."Master Quartz".."\x80"..":",
		norandom = true,
		norogue = true,		
		anim = function(mo, targets, hittargets, timer)
			if mo.hp <= mo.maxhp/5
			or mo.continue_masterdunamis --in case you somehow get healed while the anim is playing
				mo.continue_masterdunamis = true
				if timer == 15
					playSound(mo.battlen, sfx_trbuff)
					buffStat(mo, "mag")
				elseif timer > 15 and timer <= 30
					for i = 1, 8
						local thok = P_SpawnMobj(mo.x+P_RandomRange(-70, 70)*FRACUNIT, mo.y+P_RandomRange(-70, 70)*FRACUNIT, mo.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_TEAL
						thok.tics = P_RandomRange(10, 35)
					end
				elseif timer == 35
					mo.continue_masterdunamis = nil
					return true
				end
			else		
				return true
			end
		end,
	}	
	
personaList["elieskillset"].trait = "masterpixie"
attackDefs["masterpixie"] = {	
		name = "Pixie",
		type = ATK_PASSIVE,
		passive = PSV_STARTTURN,
		desc = "Recovers 0.5% SP per turn. \nAttacks have a random \nchance to cause status.",
		implicit = "masterpixie.pt2",
		traitheader = "\x82".."Master Quartz".."\x80"..":",		
		norandom = true,
		norogue = true,		
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
				local heals = max(1, target.maxsp/200 / 100)
				playSound(mo.battlen, sfx_lsheal)
				damageSP(target, -heals, DMG_NORMAL, true)
				for i = 1,10
					local ol = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_DUMMY)
					ol.sprite = SPR_NTHK
					ol.color = SKINCOLOR_MAGENTA
					ol.scale = 1
					ol.destscale = mo.scale*3
					ol.scalespeed = (mo.scale*3)/15
					ol.frame = B|FF_TRANS80
					ol.tics = i + 5
				end
			end	
			
			if timer >= 1 and timer <= 10
			and (timer%5) == 0
				local s = P_SpawnMobj(mo.x + P_RandomRange(-58, 58)<<FRACBITS, mo.y + P_RandomRange(-58, 58)<<FRACBITS, mo.z + P_RandomRange(0, 50)<<FRACBITS, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = FRACUNIT*1			
			
			elseif timer == 20
				return true
			end
		end,
	}
	
attackDefs["masterpixie.pt2"] = {		
		name = "Pixie",
		type = ATK_PASSIVE,
		passive = PSV_TRIGGERDAMAGE,
		desc = "Recovers 0.5% SP per turn. \nAttacks have a random \nchance to cause status.",
		traitheader = "\x82".."Master Quartz".."\x80"..":",		
		norandom = true,
		norogue = true,		
		anim = function(mo, target, dmg, crit)
			local cond = {COND_BURN,COND_FREEZE,COND_SHOCK,COND_BRAINWASH,COND_DIZZY,COND_HEX,COND_SILENCE,COND_SLEEP,COND_DESPAIR,COND_RAGE,COND_HUNGER,COND_POISON}
			local bossres = 0
			
			if target.boss
				bossres = (target.status_res or 0)*4
			else
				bossres = 0
			end

			if (P_RandomRange(0, 100) <= 20 + (mo.luck - bossres - target.luck))
				target.cachestatus = cond[P_RandomRange(1,#cond)]
			end	
		end,
}		